module Types where

data Expression =
    Var String |
    IntLit Integer |
    BoolLit Bool |
    UnaryOp String Expression |
    BinaryOp String Expression Expression
        deriving Show
    
data Statement =
    Assign String Expression |
    If Expression Statement Statement |
    While Expression Statement |
    Block [Statement] |
    Print Expression |
    Empty
        deriving Show

data Value = IntVal Integer | BoolVal Bool deriving Show
